unit Smartitlauscher;

interface
uses Classes, Sock, ExtCtrls, SysUtils, windows, Graphics, ComCtrls, Contnrs, Dialogs, SmartPacket;

var
        ConsoleEvents: array [0..10000] of TSmartPacket;
        oldestEvent: integer;

const arrayLength = 10000;

type SmartItsLauschen = class(TThread)
public
        nextslot: integer;
        constructor create(socket: TSock; malen: Timage; updateChartms: Cardinal; maxY: integer; minY:integer; Filter: TListView; events: TObjectList; dispmode: integer; ConsoleListView: TListview; refreshrate: TUpDown);virtual;
        procedure DrawCoordinateSystem(Bitmap: TBitmap);
        destructor Destory; virtual;
        procedure Execute; override;


private
        UDPSocket: TSock;
        ChartBitmap: TBitmap;
        Chart: TImage;
        maxYWert: integer;
        minYWert: integer;
        EventObjects: TObjectList;
        intervall: Cardinal;
        modus: integer;
        dmode: integer;
        Nextpaint: Cardinal;
        VirtualListview: TListView;
        updown: TUpdown;
        IDListView: TListView;
        function passedfilter(ID: string) : boolean;
end;

implementation

uses threeToTwo, SmartData, Math;


destructor SmartItsLauschen.Destory;
begin
ChartBitmap.free;
end;

constructor SmartItsLauschen.create(socket: TSock; malen: TImage; updateChartms: Cardinal; maxY: integer; minY:integer; Filter: TListView;  events: TObjectList; dispmode: integer; ConsoleListView: TListview; refreshrate: TUpDown);
begin
        inherited create(true);
        UDPSocket := socket;
        Chart := malen;
        intervall:= updateChartms;
        ChartBitmap:= TBitmap.Create;
        ChartBitmap.width := Chart.width;
        ChartBitmap.Height := Chart.height;
        MaxYWert:= maxy;
        minYWert:= minY;
        EventObjects := events;
        NextPaint := Gettickcount;
        IDListView := Filter;
        dmode := dispmode;
        modus := TSmartData(EventObjects.Items[0]).getMode;
        priority := tpTimeCritical;
        updown := refreshrate;
        VirtualListView := ConsoleListView;
end;

procedure SmartItsLauschen.Execute;
var EmpfangeneDaten, Host: String;
    nextplot, nextconsolerefresh:  Cardinal;
    Packet: array[0..1024] of byte;
    naechsterTyp: integer;
    j, datalen: integer;
    nextitem: integer;
    countlistitems: integer;

    ID, Location, Seq, Byte1, Byte2, Data: String;
    Event: array[0..3] of char;
    DateTime: TDateTime;
    t,d: String;
    colored: boolean;

begin
colored := false;
nextplot := Gettickcount + intervall;
nextconsolerefresh := Gettickcount + updown.Position * 50;

for j:= 0 to EventObjects.Count - 1  do begin
       TSmartData(EventObjects.Items[j]).initializeSlots;
end;

nextitem := 0;
VirtualListView.Items.Count := 0;
oldestevent := 0;
countlistitems := 0;

while (not Terminated) do begin
          empfangeneDaten := udpsocket.ReceiveDatagram(Host);
          DateTime := Time + Date;
          datalen:= Length(empfangeneDaten);

          if (datalen > 0) and (datalen <=1024) then begin
                  CopyMemory(@packet, PChar(empfangeneDaten), datalen);

                  if (packet[0]= 2) then begin

                        ID := Format('%d.%d.%d.%d.%d.%d.%d.%d', [packet[45], packet[46], packet[47],packet[48],packet[49],packet[50],packet[51],packet[52]]);
                        Location := Format('%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d.%d',[packet[1], packet[2], packet[3],packet[4],packet[5],packet[6],packet[7],packet[8],packet[9],packet[10],packet[11], packet[12], packet[13],packet[14],packet[15],packet[16],packet[17],packet[18],packet[19],packet[20],packet[21], packet[22], packet[23],packet[24],packet[25],packet[26],packet[27],packet[28],packet[29],packet[30],packet[31], packet[32], packet[33],packet[34],packet[35],packet[36],packet[37],packet[38],packet[39],packet[40],packet[41], packet[42], packet[43],packet[44]]);
                        Seq := Format('%d', [packet[53]]);
                        if passedfilter(ID) then begin

                                //Insert into DataObjects
                                for j:= 0 to EventObjects.Count - 1 do begin
                                        TSmartData(EventObjects.Items[j]).checkInData(packet, Length(empfangeneDaten));
                                end;

                                naechsterTyp := 54;
                                colored := not colored;
                                while (naechsterTyp < datalen - 2) do begin

                                        ConsoleEvents[nextitem].ID := ID;

                                        ConsoleEvents[nextitem].Location := Location;
                                        ConsoleEvents[nextitem].Seq:= Seq;

                                        Byte1 := Format('%d', [packet[naechsterTyp]]);
                                        Byte2 := Format('%d', [packet[naechsterTyp + 1]]);

                                        c2_to_3(@packet[naechsterTyp], 2, Event);

                                        ConsoleEvents[nextitem].EventByte1 := Byte1;
                                        ConsoleEvents[nextitem].EventByte2 := Byte2;
                                        ConsoleEvents[nextitem].Event := AnsiStrUpper(Event);

                                        Data:='';
                                        for j := 0 to packet[naechsterTyp + 2] - 1 do begin
                                                Data := Data + InttoStr(packet[naechsterTyp + 3 + j]) + ' ';
                                        end;
                                        ConsoleEvents[nextitem].Data := Data;

                                        t := TimeToStr(DateTime);
                                        d := DateToStr(DateTime);
                                        ConsoleEvents[nextitem].Time:= t;
                                        ConsoleEvents[nextitem].Date:= d;


                                        ConsoleEvents[nextitem].colored:= colored;

                                        if countlistitems = arrayLength then oldestevent := (oldestevent + 1) mod arraylength;

                                        countlistitems := max(nextitem + 1, countlistitems);

                                        nextitem := (nextitem + 1) mod arrayLength;
                                        naechsterTyp:= naechsterTyp + 2 + 1 + packet[naechsterTyp + 2];
                                end;
                        end;
                  end;
          end;


          if gettickcount > nextplot then begin

                for j:= 0 to EventObjects.Count - 1 do begin
                        TSmartData(EventObjects.Items[j]).switchToNextSlot;
                end;
                nextplot:= nextplot + intervall;
          end;

          if gettickcount > nextpaint then begin
                Chartbitmap.Canvas.Lock;

                DrawCoordinateSystem(Chartbitmap);

                //DrawData
                 for j:= 0 to EventObjects.Count - 1 do begin
                 case dmode of
                        0: TSmartData(EventObjects.Items[j]).repaintData(Chartbitmap);
                        1: TSmartData(EventObjects.Items[j]).repaintDataContinuous(Chartbitmap);
                        2: TSmartData(EventObjects.Items[j]).repaintDataPoint(Chartbitmap);
                 end;
                 end;

                Chart.Canvas.Lock;
                Chart.Canvas.Draw(0,0, ChartBitmap);
                Chart.Canvas.Unlock;

                Chartbitmap.Canvas.Unlock;
                nextpaint:= nextpaint + 100;

          end;

          if gettickcount > nextconsolerefresh then begin
                if (countlistitems >= 1) then begin
                        VirtualListView.Items.Count := countlistitems;
                        VirtualListView.ItemFocused := VirtualListView.items[VirtualListView.Items.count -1];
                        VirtualListView.items[VirtualListView.Items.count -1].makeVisible(true);
                        VirtualListView.Repaint;
                end;
                nextconsolerefresh := nextconsolerefresh + updown.Position * 50;
          end;
end;
VirtualListView.Items.Count := countlistitems;
VirtualListView.Repaint;
end;

function Smartitslauschen.passedfilter(ID: String): boolean;
var i: integer;
    filter: string;
    nextitem: TListItem;

begin

passedfilter := false;

if idlistview.SelCount = 0 then
        passedfilter := true
else begin
        nextitem := idlistview.Selected;
        for i := 1 to idlistview.selcount do begin
                filter := nextitem.Caption;
                nextitem := idlistview.GetNextItem(nextitem, sdbelow, [isSelected]);
                if ((CompareStr(filter, ID) = 0) or (CompareStr(filter, '255.255.255.255.255.255.255.255') = 0)) then begin
                        passedfilter := true;
                        break;
                end;

        end;
end;

end;

procedure Smartitslauschen.DrawCoordinateSystem(Bitmap: TBitmap);
var
i: integer;
beschriftung: integer;
letzteBeschriftung: Cardinal;


begin
        Bitmap.Canvas.Pen.Color := clwhite;
        Bitmap.Canvas.Brush.Color := clwhite;
        Bitmap.Canvas.Rectangle(0, 0, Bitmap.Width, Bitmap.Height);

        Bitmap.Canvas.Pen.Color := clSilver;
        for i := 1 to 24 do Bitmap.Canvas.Polyline([Point(i * 20, 0),Point(i * 20 , 300)]);
        for i:= 1 to 14 do Bitmap.Canvas.Polyline([Point(0, i*20), Point(500, i*20)]);

        Bitmap.Canvas.pen.Color := clblack;
        Bitmap.Canvas.Polyline([Point(0,300), Point(500,300)]);
        Bitmap.Canvas.Polyline([Point(5,295), Point(0,300), Point(5,305)]);

        for i := 1 to 50 do Bitmap.Canvas.Polyline([Point(i * 10, 300),Point(i *10 , 304)]);

        Bitmap.Canvas.TextOut(0,280,'time');

        if modus = 0 then Bitmap.Canvas.TextOut(430,10,'Frequency') else
                                  Bitmap.Canvas.TextOut(470,10,'Data');

        Bitmap.Canvas.Polyline([Point(500,300), Point(500,0)]);
        Bitmap.Canvas.Polyline([Point(495,5), Point(500,0), Point(505,5)]);

        for i:= 1 to 30 do Bitmap.Canvas.Polyline([Point(500, i*10), Point(505, i*10)]);

        if (MaxYWert - MinYWert) < 10 then letzteBeschriftung := MaxYWert - MinYWert else letzteBeschriftung := 10;


        for i:= 0 to letzteBeschriftung do begin
                         beschriftung := round(MinYWert + i * (MaxYWert - MinYWert) / letzteBeschriftung);
                         Bitmap.Canvas.TextOut(510, 300 - round(i * 300 / letzteBeschriftung) - 5 , InttoStr( beschriftung));
        end;


        for i:= 0 to 15 do begin
                beschriftung := round(i * intervall * 500 / 15);
                Bitmap.Canvas.TextOut(500 - Round(i * 500/15 ) , 310, InttoStr(beschriftung));
        end;
        
end;

end.
