unit programparticle;

interface
uses Classes, SmartHelo, Sock, Windows, ComCtrls, SysUtils, Dialogs, ProgramGUI;

type TProgramParticle = class(TThread)
        constructor create(CallBack: pointer; IForm: TProgramForm; SendSock: TSock; ListenSock: TSock; idprogram: array of byte; hexfile: string); virtual;
        procedure Execute; override;
private
        SendSocket: TSock;
        ListenSocket: TSock;
        id: array[0..7] of byte;
        hfile: string;
        InfoForm: TProgramForm;
        ProgressBar: pointer;
end;


implementation
uses otaplib;

constructor TProgramParticle.create(CallBack: pointer; IForm: TProgramForm; SendSock: TSock; ListenSock: TSock; idprogram: array of byte; hexfile: string);
var i : integer;
begin
        SendSocket := Sendsock;
        ListenSocket := ListenSock;
        for i:= 0 to 7 do id[i] := idprogram[i];
        hfile := hexfile;
        inherited create(false);
        InfoForm := IForm;
        ProgressBar := CallBack;
end;

procedure TProgramParticle.Execute;
var hid, lid: string;
    errorvalue: integer;
    msg: string;


begin
hid := Format('%u.%u.%u.%u',[id[0],id[1],id[2],id[3]]);
lid := Format('%u.%u.%u.%u',[id[4],id[5],id[6],id[7]]);
InfoForm.Finish.Enabled := false;
InfoForm.Status.caption := 'Programming...';
errorvalue := otaprogram(ProgressBar, StrToInt(SendSocket.PortName), StrToInt(ListenSocket.PortName), pchar(hid), pchar(lid), pchar(hfile));
case errorvalue of
        0:                              msg:= 'Programming was successful!';
        INVALID_HIGH_ID:                msg := 'Invalid high ID!';
        INVALID_LOW_ID:                 msg:='Invalid low ID!';
        INVALID_CLIENT_PORT:            msg:= 'Invalid send port!';
        INVALID_SERVER_PORT:            msg:= 'Invalid recieve port!';
        WINSOCK_MISSING:                msg:= 'Winsock not found!';
        WRONG_WINSOCK:                  msg:= 'Wrong winsock version!';
        WSA_ERROR:                      msg:= 'WSA Error!';
        BROADCASTERROR:                 msg:= 'Error with broadcasting packets!';
        PIC_ERROR:                      msg:= 'PIC Error! Program too large?';
        CRC_ERROR:                      msg:= 'CRC Error!';
        PRG_TOO_BIG:			msg:= 'Program too big!';
        WRONG_VERSION:			msg:= 'Wrong OTAP-Version!';
        WRONG_HEX_FILE:			msg:= 'Wrong HEX-File Type!';
        TOO_MANY_PROGRAM_SECTIONS:      msg:= 'Too many program sections in program!';
        NO_START_ACK:                   msg:= 'Start ACK not recieved. Particle not ready?';
        MISSING_SEQ:                    msg:= 'Missing sequence number!';
        PROGRAMMING_ERROR:              msg:= 'Programming error!';
end;
InfoForm.Status.Caption := msg;
InfoForm.Finish.Enabled := true;
end;

end.
 