/*
*
*	ACL Stack Header
*	ACL.h
*	TecO, University of Karlsruhe
*	Author:		Michael Beigl
*	Date:		7.3.2002
*	Version:        0.1
*	known bugs:
*	todo:
*
*/

#ifndef _ACL_H_
#define _ACL_H_

//#define UInt8 byte
#include "common.h"
#include "dlc.h"

unsigned char *ACLpkt_in;				// points to ACL position in packet
unsigned char *ACLpkt_out;
unsigned char ACLptr_out; 
boolean ACLpkt_ready;

//#include "dlc_cl.c"



void ACL_send(UInt8 aclsize);

UInt8 ACL_fieldstrength_rec();

unsigned char* ACL_begin_rec();

UInt8 ACL_version_rec();

UInt8 ACL_len_rec();

UInt8 ACL_seqno_rec();

void ACL_ip_rec(UInt8 *ip);

// Detect the type in the in-packet
// returns position of following len of data-byte if found, 0 if not
UInt8 ACL_detect_type(UInt8 first, UInt8 sec);



boolean ACL_pfind_type(UInt8 position, UInt8 type_high, UInt8 type_low);

boolean ACL_find_type(UInt8 type_high, UInt8 type_low, UInt8 *len, UInt8** data);
unsigned char* ACL_decode(unsigned char* type, unsigned char* decType);

boolean HELO_det(UInt8** ip);
boolean SWITCH_det(UInt8* turns);
boolean ACCL_det(UInt8* x, UInt8* y);
boolean SMARTIT_det(UInt8* version);
boolean CHAIR_det(UInt8** version);
boolean OLEH_det(UInt8** ip);
boolean HELO_det(UInt8 **ip);

void tuple_add(UInt8 type_high, UInt8 type_low, UInt8 len, UInt8* data);
void OLEH_add(UInt8* ip);
void CHAIR_add(UInt8 version);
void HELO_add(UInt8* ip);
void SWITCH_add(UInt8 turns);
void SMARTIT_add(UInt8 version);
void ACCL_add(UInt8 x, UInt8 y);

void ACLsend();

/////////////////////////////////////////////////////
boolean ACL_icmp_check();


#endif