// *************************************************************************
//				Airprogram
//				Version 0.5
//	
//				cml.c
//				contains functions for command line parameters evaluation
//
//		Michael Beigl, TecO, Karlsruhe University, 16.05.02
//		www.teco.edu



#include <stdlib.h>
#include <string.h>
#include <stddef.h>
#include <stdio.h>

#include "common.h" // contains all global Variables for this project !!!!
#include "otaplib.h"

// extracts all command line parameters and sets global variables according to 
// parameters in the command line
// also contains the DEFAULT values of global variables
void comp_command(u_short sport, u_short cport, char *hid, char *lid, char *hfile)
{
	char s[255];

	CLIENTPORT = sport;
	SERVERPORT = cport;
	OTAPVERSION = 1;
	hexfile[0] = 0;
 
	strcpy(s, hid);
	tidhigh = (IDType) inet_addr(s);
	if (tidhigh==INADDR_NONE) {
		errorvalue = INVALID_HIGH_ID;
	}
	
	strcpy(s, lid);	
	tidlow = (IDType) inet_addr(s);
	if (tidlow==INADDR_NONE)
	{
		errorvalue = INVALID_LOW_ID;
	}
	
	strcpy(hexfile, hfile);
	
	if (CLIENTPORT==0)
	{
		errorvalue = INVALID_CLIENT_PORT;	
	}

	if (SERVERPORT==0)
	{
		errorvalue = INVALID_SERVER_PORT;
	}
}
